SoDirectionalLightDragger(3)

NAME
SoDirectionalLightDragger - The SoDirectionalLightDragger class provides interactive geometry for manipulating a directional light source.

SYNOPSIS

#include <Inventor/draggers/SoDirectionalLightDragger.h>

Inherits SoDragger.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoNodekitCatalog * getNodekitCatalog (void) const
SoDirectionalLightDragger (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static const SoNodekitCatalog * getClassNodekitCatalog (void)
static void initClass (void)

  Public Attributes
SoSFRotation rotation
SoSFVec3f translation

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoDirectionalLightDragger (void)
virtual SbBool setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void setDefaultOnNonWritingFields (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoNodekitCatalog ** getClassNodekitCatalogPtr (void)
static void fieldSensorCB (void *f, SoSensor *s)
static void valueChangedCB (void *f, SoDragger *d)

  Protected Attributes
SoSFNode material
SoSFNode rotator
SoSFNode translator
SoSFNode translatorRotInv
SoSFNode translatorSep
SoFieldSensor * rotFieldSensor
SoFieldSensor * translFieldSensor

  Additional Inherited Members

Detailed Description

The SoDirectionalLightDragger class provides interactive geometry for manipulating a directional light source. Here's how the dragger looks with its default geometry in the inactive state:

 Screen Shot of Default Dragger

This dragger is well suited to use for setting up the fields of a SoDirectionalLight node, as it provides geometry for the end-user to interact with a directional vector.

The image below is an action shot example, with the directional light being red and the camera headlight turned right down.

 DirectionalLight Dragger Action Shot

For convenience, this dragger also by default contains interaction geometry for placing the dragger itself. (SoDirectionalLight nodes don't have a position field, so this was strictly not needed.)

The Coin library also includes a manipulator class, SoDirectionalLightManip, which wraps the functionality provided by this class inside the necessary mechanisms for connecting it to SoDirectionalLight node instances in a scene graph.

See also
    SoDirectionalLightManip

Constructor & Destructor Documentation

  SoDirectionalLightDragger::SoDirectionalLightDragger (void)
Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

CLASS SoDirectionalLightDragger
-->'this'
      'callbackList'
      'topSeparator'
         'motionMatrix'
-->      'material'
-->      'translatorSep'
-->         'translatorRotInv'
-->         'translator'
-->      'rotator'
         'geomSeparator'

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

CLASS SoDirectionalLightDragger
PVT   'this',  SoDirectionalLightDragger  ---
      'callbackList',  SoNodeKitListPart [ SoCallback, SoEventCallback ]
PVT   'topSeparator',  SoSeparator  ---
PVT   'motionMatrix',  SoMatrixTransform  ---
      'material',  SoMaterial  ---
PVT   'translatorSep',  SoSeparator  ---
      'translatorRotInv',  SoRotation  ---
      'translator',  SoDragPointDragger  ---
      'rotator',  SoRotateSphericalDragger  ---
PVT   'geomSeparator',  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

  SoDirectionalLightDragger::~SoDirectionalLightDragger (void) [protected], [virtual]
Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

Member Function Documentation

  SoType SoDirectionalLightDragger::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoDirectionalLightDragger::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoDragger.

  const SoFieldData ** SoDirectionalLightDragger::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoDirectionalLightDragger::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoDragger.

  const SoNodekitCatalog * SoDirectionalLightDragger::getClassNodekitCatalog (void) [static]
Returns the nodekit catalog which defines the layout of this class' kit.

  const SoNodekitCatalog * SoDirectionalLightDragger::getNodekitCatalog (void) const [virtual]
Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

  const SoNodekitCatalog ** SoDirectionalLightDragger::getClassNodekitCatalogPtr (void) [static], [protected]
Returns the pointer to the pointer of the nodekit catalog for this class.

  void SoDirectionalLightDragger::initClass (void) [static]
Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

  SbBool SoDirectionalLightDragger::setUpConnections (SbBool onoff, SbBool doitalways = FALSE) [protected], [virtual]
Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

  void SoDirectionalLightDragger::setDefaultOnNonWritingFields (void) [protected], [virtual]
(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument TRUE on part fields that should not be written upon scene graph export operations.

This is typically done when:

1.  field value is NULL and part is NULL by default
2.  it is a leaf SoGroup or SoSeparator node with no children
3.  it is a leaf listpart with no children and an SoGroup or SoSeparator container
4.  it is a non-leaf part and it is of SoGroup type and all fields are at their default values
Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call 'upwards' to your superclass' setDefaultOnNonWritingFields() method.
Reimplemented from SoDragger.

  void SoDirectionalLightDragger::fieldSensorCB (void * d, SoSensor * s) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoDirectionalLightDragger::valueChangedCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Member Data Documentation

  SoSFRotation SoDirectionalLightDragger::rotation
This field is continuously updated to contain the rotation of the current direction vector. The application programmer will typically connect this to the rotation field of a SoDirectionalLight node (unless using the SoDirectionalLightManip class, where this is taken care of automatically).
It may also of course be connected to any other rotation field controlling the direction of scene graph geometry, it does not have to part of a SoDirectionalLight node specifically.

  SoSFVec3f SoDirectionalLightDragger::translation
Continuously updated to contain the current translation from the dragger's local origo position.
This field is not used by the SoDirectionalLightManip, but may be of interest for the application programmer wanting to use the SoDirectionalLightDragger outside the context of controlling a directional light node.

  SoFieldSensor * SoDirectionalLightDragger::rotFieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SoFieldSensor * SoDirectionalLightDragger::translFieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Author
Generated automatically by Doxygen for Coin from the source code.